package benno.globe;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Point;
import java.util.Enumeration;
import java.util.Vector;

/** This object stores details about where on a plane labels have already 
been placed. 

@author Ben Clifford
@version $Revision: 1.4 $
*/

public class LabelPlane
{
	/** a Vector containing the allocated areas of the plane as Rectangles */
	private Vector allocated = new Vector();
	private Vector annotations = new Vector();

	public boolean checkAllocated(Rectangle region)
	{
		Enumeration allocatedEnumeration = allocated.elements();
		while(allocatedEnumeration.hasMoreElements())
		{
			Rectangle aRect = (Rectangle)allocatedEnumeration.nextElement();
			if(aRect.intersects(region)) return true;
		}

		// if we hit here, we have not returned true in the while loop
		// so the space is not allocated
		return false;
	}

	public Object getAnnotationFor(Point p)
	{
		for(int i=0;i<allocated.size() && i<annotations.size();i++)
		{
			Rectangle r = (Rectangle)allocated.elementAt(i);
			if(annotations.elementAt(i)!=null)
			{
				System.out.println("Checking: r="+r+" against p="+p);
			}
			if(r.contains(p)) return annotations.elementAt(i);
		}
		return null; // none found
	}

	public void allocate(Rectangle region, Object annotation)
	{
		allocated.addElement(region);
	
		annotations.addElement(annotation);
		// if(annotations!=null) System.out.println("Added annotation for "+region+" with object "+annotation);
	}

}
