//$Id: Ordering.java,v 1.4 2000/05/15 14:10:08 benc Exp $
package benno.sort;

/** An implementation of this interface represents an ordering of Objects. <br>
The ordering does not have to be defined between all pairs of objects.<br>
If an ordering is not defined between two objects, an exception should be
thrown.<br>
For example, an IntegerOrdering cannot compare an Integer with a 
GridBagLayout. <br>
The = is used for ordering, not testing for equality, and merely means that
the two objects occupy the same place in the ordering - it does not imply
that they are equal.<br>
For example, an ordering by magnitude should say the -5 = 5, even though
-5 != 5. <br>
It should also say that two Integer objects are equal if their stored value
is equal, not if they are the same object.

@version $Revision: 1.4 $

*/

public interface Ordering
{
	/** This function should order a and b. It should return:  <br>
		-1 if a is before b<br> 
		0 if a is ranked equally to b<br>
		1 if a is greater than b
	*/
	public int compare(Object a, Object b);
}

