package benno.sort;
import java.util.*;

/** An instance of this class take a Vector and reorders its elements so
that they are in random order. It works at the moment by making 
<code>10*Vector.size()</code> swaps between randomly picked elements of
the Vector.<br>
There should be some theoretical basis to this class - I need to find it
and use it. 

@author Ben Clifford
@version $Revision: 1.3 $

*/

public class VectorRandomiser
{
/** This contains the Random object that is used to reorder the vector. It is 
exposed so that other code may make use of the same random object. */

	final public Random r;

/** Creates a new randomiser, creating a new Random object to use. */
	public VectorRandomiser()
	{
		r = new Random();
	}

/** reorders the vector v so that it is in random order. */
	public void randomise(Vector v)
	{	
		for(int i=v.size()*10; i>0; i--)
		{
			int a = r.nextInt();
			int b = r.nextInt();
			a = (a<0) ? -a : a;
			b = (b<0) ? -b : b;
			a%=v.size();
			b%=v.size();

			Object temp = v.elementAt(a);
			v.setElementAt(v.elementAt(b),a);
			v.setElementAt(temp,b);
		}
	}

}
