//$Id: VectorSorter.java,v 1.5 2000/06/29 16:33:34 benc Exp $
package benno.sort;

import java.util.Vector;
import java.util.Enumeration;

/**

This class provides a static method that will reorder a supplied vector
according to the supplied ordering object.

@author Ben Clifford
@version $Revision: 1.5 $

*/

public class VectorSorter
{

	/** returns an ordered version of the supplied vector, ordered using
	    the supplied ordering. 
@param v The vector to be reordered
@param o The order into which the vector should be placed
@returns A new vector containing the reordered elements of the input vector v

*/

	public static Vector sort(final Vector v, final Ordering o)
	{
		if(v.size()==0) return v;

		Object array[];
		array = new Object[v.size()];	
		v.copyInto(array);

		internal_sort(array,o,0,v.size()-1);
		
		Vector rv=new Vector(v.size());
		for(int i=0; i<v.size(); i++)
		{
			rv.addElement(array[i]);
		}
		return rv;
	}

	private static void internal_sort(final Object[] a, final Ordering o,
			final int start, final int end)
	{

		// first check for 0 or one elements
		if(end-start < 1) // i.e. we have 0 or 1 elements
			return; // because already sorted
/*
		if(end-start == 1) // i.e. there are 2 elements	
		{
			Object l = a[start];
			Object r = a[end];

			if(o.compare(l,r) != 1) // l<=r
				return; // already ordered	
			else
			{	
				Object swap;
 				swap = a[start];
				a[start] = a[end];
				a[end] = swap;
				return;
			}
		}

*/

		// if we reach this far and we haven't returned,
		// then there are more than two elements in the 
		// vector.

		int midpoint = (start+end)/2;

		internal_sort(a,o,start,midpoint);
		internal_sort(a,o,midpoint+1,end);

		// so at this point, both halves are sorted

		// now merge them

		Object b[] = new Object[end-start+1];
		
		int li=start;
		int ri=midpoint+1;
		int bi=0;
		while(li<=midpoint && ri<=end)
		{
			if(o.compare(a[li],a[ri]) == -1)
				b[bi++] = a[li++];
			else
				b[bi++] = a[ri++];
		}
		// so now we have copied everything through, and
		// we just need to top up the rest.
		while(li<=midpoint)
			b[bi++] = a[li++];
		while(ri<=end)
			b[bi++] = a[ri++];

		// now copy all back into a
		for(int i=start; i<=end; i++)
		{
			a[i] = b[i-start];
		}
	}
}
